// AtMega8
// 8.000Mhz RC 

#include <iom8v.h>
#include <macros.h>

unsigned int cnt;//    1
unsigned char p1,p2,p3,p4, zeroes=0; //   

#pragma interrupt_handler timer1_ovf_isr:iv_TIM1_OVF
void timer1_ovf_isr(void)
{
 //TIMER1 
 TCNT1H = 0x00; //reload counter high value
 TCNT1L = 0x00; //reload counter low value
 PORTC=0;//   ,   
}

#pragma interrupt_handler int0_isr:iv_INT0
void int0_isr(void)//  (  , . MCUCR  2  3)
{ 
 cnt=TCNT1;// 
 TCNT1=0;// ,      
 //    -    ( 3 , 1 , 300  )
 
      if(cnt<160)  {p1++;}//f>3k 1m/3000/2=160 -       
 else if(cnt<400)  {p2++;}//1k<f<3k  1m/1000/2=500
 else if(cnt<1600) {p3++;}//300<f<1k 1m/300/2=1666
 else              {p4++;}//f<300
 
 zeroes++;//  
 if(zeroes>50)//    -       
 {
   PORTC=0;//  
   
   //      
   if(p1>15)PORTC|= (1<<0);
   if(p2>25)PORTC|= (1<<1);
   if(p3>15)PORTC|= (1<<2);
   if(p4>5)PORTC|= (1<<3);
   
   p1=p2=p3=p4=0;//   
   zeroes=0;
 }
 
}

void main(void)
{
 CLI(); // 
 //  ,  ,   

 PORTB = 0xFF;
 DDRB  = 0x00;
 PORTC = 0x40;
 DDRC  = 0x3F;
 PORTD = 0xFF;
 DDRD  = 0x00;


//TIMER1  
 TCCR1B = 0x00;
 TCNT1H = 0xFF;
 TCNT1L = 0xF0;
 OCR1AH = 0x00;
 OCR1AL = 0x10;
 OCR1BH = 0x00;
 OCR1BL = 0x10;
 ICR1H  = 0x00;
 ICR1L  = 0x10;
 TCCR1A = 0x00;
 TCCR1B = 0x02; //  1  (8   8) 

 MCUCR = 0x05;
 GICR  = 0x40;
 TIMSK = 0x04; 
 
 SEI(); //!
 while(1);//
}

